package ru.dbotthepony.kstarbound.defs.item.impl

import com.google.common.collect.ImmutableList
import ru.dbotthepony.kstarbound.defs.IThingWithDescription
import ru.dbotthepony.kstarbound.defs.RegistryReference
import ru.dbotthepony.kstarbound.defs.ThingDescription
import ru.dbotthepony.kstarbound.defs.item.IInventoryIcon
import ru.dbotthepony.kstarbound.defs.item.api.IItemDefinition
import ru.dbotthepony.kstarbound.defs.item.InventoryIcon
import ru.dbotthepony.kstarbound.defs.item.ItemRarity
import ru.dbotthepony.kstarbound.io.json.builder.JsonFactory
import ru.dbotthepony.kstarbound.io.json.builder.JsonFlat

@JsonFactory
data class ItemDefinition(
	@JsonFlat
	val descriptionData: ThingDescription,

	override var itemName: String,
	override var price: Long = 0,
	override var rarity: ItemRarity = ItemRarity.COMMON,
	override var category: String,
	override var inventoryIcon: ImmutableList<IInventoryIcon>? = null,
	override var itemTags: ImmutableList<String> = ImmutableList.of(),
	override var learnBlueprintsOnPickup: ImmutableList<RegistryReference<IItemDefinition>> = ImmutableList.of(),
	override var maxStack: Long = 9999L,
	override var eventCategory: String? = null,
	override var consumeOnPickup: Boolean = false,
	override var pickupQuestTemplates: ImmutableList<String> = ImmutableList.of(),
	override var tooltipKind: String = "normal",
	override var twoHanded: Boolean = false,
	override var radioMessagesOnPickup: ImmutableList<String> = ImmutableList.of(),
	override var fuelAmount: Long = 0,
	override var pickupSoundsSmall: ImmutableList<String> = ImmutableList.of(),
	override var pickupSoundsMedium: ImmutableList<String> = ImmutableList.of(),
	override var pickupSoundsLarge: ImmutableList<String> = ImmutableList.of(),
	override var smallStackLimit: Long? = null,
	override var mediumStackLimit: Long? = null,
) : IItemDefinition, IThingWithDescription by descriptionData
